package brownstrategy.oracles;

import game.Game;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * This oracle makes its predictions based on each agents
 * moves individually.  For any given number of last moves
 * it checks for matching sequences in the agents history
 * and determines how it moved after that sequence of moves
 * previously seen.
 * 
 * @author jberg
 *
 */

public class PrevSequenceZeroContextOracle extends AbstractPrevSequenceOracle {

	public PrevSequenceZeroContextOracle(Game g, long seed, String options) {
		super(g,seed,options);
	}

	public int[] getOppDist(int opp) {
		int[] arr = new int[12];
		ArrayList<Integer> moves;
		if(opp == 0) {
			moves = player1Moves;
		}
		else if (opp == 1) {
			moves = player2Moves;
		}
		else {
			moves = player3Moves;
		}
		for (Integer move : moves) {
			arr[move] = arr[move] + 1;
		}
		return arr;
	}

	public String toString() {
		return "PrevSequenceZeroContextOracle";
	}

	public PrevSequenceZeroContextOracle getCopy() {
		return new PrevSequenceZeroContextOracle(_g,_seed,_options);
	}

	@Override
	public PrevSequenceZeroContextOracle getCopy(Game g, long seed, String options) {
		return new PrevSequenceZeroContextOracle(g,seed,options);
	}

}