package brownstrategy.oracles;

import brownstrategy.agent.Agent;
import brownstrategy.agent.NondeterministicAgent;
import game.Game;
import util.Constants;


public class UniformDistributionOracle extends NondeterministicAgent {
		
	private final double[] uniformDistribution;
	
	
	public UniformDistributionOracle(Game g, long seed, String options) {
		super(g, seed, options);
		
		//Create uniform distribution
		uniformDistribution = new double[Constants.NUM_CLOCK_POSITIONS];
		double prob = 1.0 / Constants.NUM_CLOCK_POSITIONS;

		for (int pos=0; pos<Constants.NUM_CLOCK_POSITIONS; pos++) {
				uniformDistribution[pos] = prob;
		}
	}
	
	
	

	public double[] getActionDistribution() {
		return uniformDistribution;
	}


	
//	public AbstractOracle getCopy() {
//		//Just return a completely new instance of this class. 
//		return new UniformDistributionOracle();
//	}

	
	public void observeOutcome(int[] actions) {
		//Don't need to update anything.
		return;
	}




	@Override
	public Agent getCopy() {
		return new UniformDistributionOracle(_g,_seed,_options);
	}




	@Override
	public Agent getCopy(Game g, long seed, String options) {
		return new UniformDistributionOracle(g,seed,options);
	}




	@Override
	public void lookAhead(int[] actions) {
		//nothing to do
	}

	@Override
	public void lookBack() {
		//nothing to do
	}

	
}
